package lab2;

/** 
 * Classe ListNode:
 *
 * Classe usata per descrivere il singolo nodo di una lista.
 * &Egrave; possibile creare liste con un nodo isolato e liste
 * unidirezionali in base al <em>numero</em> di argomenti del
 * costruttore.  La classe viene usata per l'implementazione mediante
 * liste dei tipi di dato astratto (il tipo di dato astratto "lista
 * concatenatata" &egrave; diverso da ListNode, che pu&ograve essere 
 * usata o meno nella sua implementazione).
 * @version 2.0 Febbraio 2001 
 * @author A. Brogi      (<A HREF="mailto:brogi@di.unipi.it">brogi@di.unipi.it</A>)
 * @author A. Corradini  (<A HREF="mailto:andrea@di.unipi.it">andrea@di.unipi.it</A>)
 * @author F. Gadducci   (<A HREF="mailto:gadducci@di.unipi.it">gadducci@di.unipi.it</A>)
 * @author R. Grossi     (<A HREF="mailto:grossi@di.unipi.it">grossi@di.unipi.it</A>)
 * @author C. Montangero (<A HREF="mailto:monta@di.unipi.it">monta@di.unipi.it</A>)
 * @author F. Romani     (<A HREF="mailto:romani@di.unipi.it">romani@di.unipi.it</A>)
 * @author L. Semini     (<A HREF="mailto:semini@di.unipi.it">semini@di.unipi.it</A>)
 */
public class ListNode {
    public Object   element;
    public ListNode next;

    // Costruttore nodo isolato
    public ListNode( Object element) {
        this( element, null );
    }

    // Costruttore nodo per liste unidirezionali, dove element e' non null
    public ListNode( Object element, ListNode next ) {
	if ( element == null )
	    throw new IllegalArgumentException( );
        this.element  = element;
        this.next     = next;
    }
}
