package lab2;

import  lab2.Exceptions.*;

/**
 * Interfaccia Stack:
 *
 * Specifica dei metodi per la gestione della pila, con riferimento
 * alle classi di Java Collections API disponibili in
 * <code>java.util.*</code>.
 * <pre>
 * ******************* METODI PUBBLICI **********************
 * Object push( Object x)  --> Inserisce x in cima alla pila
 * Object pop( )           --> Estrae dalla cima della pila
 * Object peek( )          --> Restituisce l'elemento in cima 
 * boolean isEmpty( )      --> Verifica se la pila e' vuota
 * void clear( )           --> Svuota la pila
 * ****************** ECCEZIONI ******************************
 * pop e peek generano EmptyStackException con pila vuota
 * </pre>
 * @version 2.0 Febbraio 2001
 * @author A. Brogi      (<A HREF="mailto:brogi@di.unipi.it">brogi@di.unipi.it</A>)
 * @author A. Corradini  (<A HREF="mailto:andrea@di.unipi.it">andrea@di.unipi.it</A>)
 * @author F. Gadducci   (<A HREF="mailto:gadducci@di.unipi.it">gadducci@di.unipi.it</A>)
 * @author R. Grossi     (<A HREF="mailto:grossi@di.unipi.it">grossi@di.unipi.it</A>)
 * @author C. Montangero (<A HREF="mailto:monta@di.unipi.it">monta@di.unipi.it</A>)
 * @author F. Romani     (<A HREF="mailto:romani@di.unipi.it">romani@di.unipi.it</A>)
 * @author L. Semini     (<A HREF="mailto:semini@di.unipi.it">semini@di.unipi.it</A>)
 */

public interface Stack {
    /**
     * Inserisce un oggetto in cima alla pila.
     * @param x  l'oggetto da inserire.
     * @return   l'oggetto inserito.
     * @exception IllegalArgumentException se l'argomento passato
     *            &egrave; <code>null</code>.  
     */
    Object push( Object x );

    /**
     * Rimuove e restituisce l'oggetto in cima alla pila.
     * @return   l'oggetto in cima.
     * @exception EmptyStackException con pila vuota.
     */
    Object pop( );

    /**
     * Restituisce l'oggetto in cima alla pila senza estrarlo.
     * @return   l'oggetto in cima.
     * @exception EmptyStackException con pila vuota.
     */
    Object peek( );

    /**
     * Verifica che la pila sia logicamente vuota.
     * @return  <code>true</code> se la pila &egrave; vuota;
     *          <code>false</code> altrimenti.
     */
    boolean isEmpty( );

    /**
     *  Svuota la pila.
     */
    void clear( ); 
}
