class VettoreOrdinato {
   private Comparable vettore[]; // In questa versione di VettoreOrdinato
                                // si possono inserire solo oggetti che
                                // implementano l'interfaccia Comparable.
   private int maxElementi;  // Numero massimo di elementi
   private int curElementi;  // Numero di elementi effettivamente presenti
   
   public VettoreOrdinato (int maxElementi) { // costruttore
      this.maxElementi = maxElementi;
      vettore = new Comparable[maxElementi];
      curElementi = 0;
   }
   public int maxElementi () { return maxElementi; }
   public int elementi () { return curElementi; }
   
   protected boolean aggiungi (Comparable elemento) { 
      // aggiunge un elemento se possibile, altrimento ritorna false 
      if (elemento != null && curElementi < maxElementi) {
         vettore[curElementi++] = elemento;
         return true;
      } else
         return false;
   }
   public Comparable leggi (int indice) {  //  legge un elemento
      if (indice >= 0 && indice < curElementi)
         return (vettore[indice]);
      else   
         return null;
   }
   public void ordina () {  //ordina elementi usando 'compareTo()'
      int i, j, num;
      Comparable temp;
      num = curElementi;
      for (i = 0; i < num; i++)
         for (j = i + 1; j < num; j++)
	     if (vettore[i].compareTo(vettore[j]) > 0)
               {  temp = vettore[i];
                  vettore[i] = vettore[j];
                  vettore[j] = temp;  }
     }
}
