public class Razionale 
{

    protected int numerator, denominator;

    // Inizializza il numero razionale verificando che il denominatore
    // sia diverso da zero, e mettendo il segno solo al numeratore.
    public Razionale(int numer, int denom)
    {
	if (denom == 0)
	    denom = 1;
	if (denom < 0){
	    numer = numer * -1;
	    denom = denom * -1;
	}
	
	numerator = numer;
	denominator = denom;
	
	riduci();
    }
    
    // Somma il numero razionale corrente a quello passsato come 
    // parametro. Il denominatore comune e' calcolato moltiplicando 
    // i singoli denominatori.
    public Razionale somma(Razionale op2)
    {
	int commonDenominator = denominator * op2.getDenominatore();
	int numerator1 = numerator * op2.getDenominatore();
	int numerator2 = op2.getNumeratore() * denominator;
	int sum = numerator1 + numerator2;

	return new Razionale(sum, commonDenominator);
    }

    // Sottrae il numero razionale passato come parametro 
    // da quello corrente.
    public Razionale sottrazione (Razionale op2)
    {
	int commonDenominator = denominator * op2.getDenominatore();
	int numerator1 = numerator * op2.getDenominatore();
	int numerator2 = op2.getNumeratore() * denominator;
	int difference = numerator1 - numerator2;

	return new Razionale(difference, commonDenominator);
    }

    // Moltiplica il numero razionale corrente con quello 
    // passato come parametro.
    public Razionale prodotto(Razionale op2)
    {
	int numer = numerator * op2.getNumeratore();
	int denom = denominator * op2.getDenominatore();

	return new Razionale(numer, denom);
    }

    // Divide il numero razionale corrente con quello 
    // passato come parametro (moltiplicandolo per il
    // reciproco del parametro).
    public Razionale divisione(Razionale op2)
    {
	return prodotto(op2.reciproco());
    }

    // Restituisce il reciproco del numero razionale corrente.
    public Razionale reciproco()
    {
	return new Razionale(denominator, numerator);
    }

    // Restituisce il numeratore del numero razionale corrente.
    public int getNumeratore()
    {
	return numerator;
    }

    // Restituisce il denumeratore del numero razionale corrente.
    public int getDenominatore()
    {
	return denominator;
    }
   
    // Determina se il numero razionale corrente e' uguale a quello
    // passato come parametro. Suppone che siano entrambi ridotti.
    public boolean equals(Razionale op2)
    {
	return(numerator == op2.getNumeratore() && 
	       denominator == op2.getDenominatore());
    }

    // Restituisce il numero razionale corrente in formato testuale.
    public String toString()
    {
	String result;
	if (numerator == 0)
	    result = "0";
	else
	    if (denominator == 1)
		result = ""+numerator;
	    else
		result = numerator + "/" + denominator;
	
	return result;
    }


    // Calcola e restituisce il massimo comun divisore dei due 
    // parametri interi.
    public int mcd(int num1, int num2)
    {
	while (num1 != num2)
	    if (num1 > num2)
		num1 = num1 - num2;
	    else
		num2 = num2 - num1;
	
	return num1;
    }

    // Riduce il numero razionale corrente dividendo numeratore
    // e denominatore per il loro massimo comun divisore.
    public void riduci()
    {
	int common;
	common = mcd (Math.abs(numerator), denominator);
	numerator = numerator / common;
	denominator = denominator / common;
    }
}



