class Quadrilatero
{
    private double x1, y1, x2, y2, x3, y3, x4, y4;
    
    public Quadrilatero()
    {
	x1 = y1 = x2 = y2 = x3 = y3 = x4 = y4 = 0;
    }
    
    public Quadrilatero(double x1, double y1, double x2, double y2, double x3, double y3, double x4, double y4)
    {
	this.x1 = x1;
	this.y1 = y1;
	this.x2 = x2;
	this.y2 = y2;
	this.x3 = x3;
	this.y3 = y3;
	this.x4 = x4;
	this.y4 = y4;
    }
    
    public String toString()
    {
	return getClass().getName() + " di vertici " + "(" + x1 + "," + y1 + "), (" + x2 + "," + y2 + "), (" + x3 + "," + y3 + "), (" + x4 + "," + y4 + ").";
    }
}

class Trapezio extends Quadrilatero
{
    public Trapezio(double x1, double y1, double x2, double y2, double baseMaggiore, double baseMinore)
    {
	super(x1, y1, x2, y2, x1 + baseMinore, y1, x2 + baseMaggiore, y2);
    }
}

class Parallelogramma extends Trapezio
{
    public Parallelogramma(double x1, double y1, double x2, double y2, double lato)
    {
	super(x1, y1, x2, y2, lato, lato);
    }
}
   
class Rettangolo extends Parallelogramma
{
    public Rettangolo(double x1, double y1, double lato1, double lato2)
    {
	super(x1, y1, x1, y1 + lato1, lato2);
    }
}

class Quadrato extends Rettangolo 
{
    public Quadrato(double x1, double y1, double lato)
    {
	super(x1,y1,lato, lato);
    }
}

public class Gerarchia
{
    public static void main(String[] args)
    {
	Quadrilatero q;
	q = new Quadrilatero(0,0,2,2,9,2,12,1);
	System.out.println(q.toString());
	q = new Trapezio(0,0,2,2,9,12);
	System.out.println(q.toString());
	q = new Parallelogramma(0,0,2,2,9);
	System.out.println(q.toString());
	q = new Rettangolo(0,0,2,4);
	System.out.println(q.toString());
	q = new Quadrato(0,0,2);
	System.out.println(q.toString());
    }
}






