import lab2.*;
import lab2.Exceptions.*;

abstract class SwapStackInterface {
         
  protected Stack scambia;
  
  public SwapStackInterface ( Stack input ) {
    scambia = input;
  }
  
  /**       
   * Scambia il contenuto dei primi due elementi della pila           
   * @return una nuova pila, che contiene i valori della pila    
   * che esegue il metodo, con i primi due elementi scambiati           
   */          
  abstract Stack swap ( ) ;
}

public class SwapStack extends SwapStackInterface
{
  public SwapStack(Stack input)
  {
    super(input);
  }
  
  Stack swap()
  {
    // si utilizza il metodo clone dell'esercizio n. 3
    Stack nuovaPila = Clone.clone(scambia);
    
    Object tmp1, tmp2;
    
    if(!nuovaPila.isEmpty()) tmp1 = nuovaPila.pop();
    else throw new EmptyStackException("Pila vuota");
    
    if(!nuovaPila.isEmpty()) tmp2 = nuovaPila.pop();
    else throw new EmptyStackException("Pila con un solo elemento");
    
    nuovaPila.push(tmp1);
    nuovaPila.push(tmp2);
    
    return nuovaPila;
  }
  
  // metodo main di prova:
  
  public static void main(String args[]) 
  {
    Stack input = new ArrayStack();
    input.push("3");
    input.push("2");
    input.push("1");
    SwapStack prova = new SwapStack(input);
    Stack modificata = prova.swap();
    System.out.println("Pila originale: ");
    while(!input.isEmpty())
      System.out.println(input.pop());
    System.out.println("Pila modificata: ");
    while(!modificata.isEmpty())
	    System.out.println(modificata.pop());
   }
}



