import lab2.*;

public class MetodiAlberiBinari 
{
  public static boolean foglia ( BinNode r )
  {
      if(r == null) throw new IllegalArgumentException();  
      return (r.left == null && r.right == null);
  }
  
  public static int contaInterni ( BinNode r )
  {
    // caso base (albero vuoto)
    if (r == null) return 0;
    
    // caso ricorsivo (albero non vuoto)
    else if (foglia(r)) return 0;
    else return (1 + contaInterni(r.left) + contaInterni(r.right));
  }
  
  public static BinNode zio ( BinNode r )
  {
    if ((r == null) || (r.parent == null) || (r.parent.parent == null)) 
      return null;
    else if(r.parent.parent.left == r.parent) return r.parent.parent.right;
    else return r.parent.parent.left;
  }

  public static int altezza ( BinNode r )
  { 
    if (r == null) return 0;
    else return 1 + Math.max(altezza(r.left), altezza(r.right));
  }

  public static int contaFU ( BinNode t )
  {
    if (t == null) return 0;
    else if(isFU(t)) return 1 + contaFU(t.left) + contaFU(t.right);
    else return contaFU(t.left) + contaFU(t.right);
  }

  private static boolean isFU(BinNode r)
  {
    if (r == null) return false;
    else if (r.parent == null) return false;
    else if ((r.parent.left != null) && (r.parent.right != null))
      return false;
    else return true;
  }
  
  public static int nodi ( BinNode t, int l ) 
  {
    if (l < 0) throw new IllegalArgumentException();
    if (t == null) return 0;
    else if (l == 0) return 1;
    else return nodi(t.left, l-1) + nodi(t.right, l-1);
  }
}
  






