import lab2.*;

public class IntegerQueue extends IntegerQueueInterface
{
  public IntegerQueue(Queue input) 
  {
    super(input);
  }
  
  /** 
   * Restituisce il pi alto elemento della coda, assumendo 
   * che gli elementi contenuti siano istanze di Integer. 
   * Lancia una EmptyQueueException se 'prior'  null 
   * oppure  la coda vuota. 
   */ 
  public Integer maxDequeue() 
  {
    Queue  q1 = new ArrayQueue();
    Object o = prior.dequeue();
    int max = ((Integer) o).intValue();
    while (!prior.isEmpty()) 
      {
	o = prior.dequeue();
	int val = ((Integer) o).intValue();
	if (max < val) {
	  q1.enqueue(new Integer(max));
	  max = val;
	}
	else
	  q1.enqueue(o);
      }
    while (!q1.isEmpty()) {
      prior.enqueue(q1.dequeue());
    }
    return new Integer(max);
  }

  /** 
   * Ordina il contenuto della coda, assumendo che 
   * gli elementi contenuti siano istanze di Integer 
   */ 
  public void ordina () 
  {
    Stack  q1 = new ArrayStack();
    while (!prior.isEmpty()) 
      q1.push(this.maxDequeue());
    while (!q1.isEmpty()) 
      prior.enqueue(q1.pop());
  }
  
  // metodo main di prova
  public static void main(String[] args) 
  {
    Queue q = new ArrayQueue();
    for(int i=0; i<10;i++) 
      q.enqueue(new Integer((int) (Math.random() * 10)));
    IntegerQueue IQ = new IntegerQueue(q);
    System.out.print("Coda originale: ");
    stampaQ(q);
    IQ.ordina();
    System.out.print("Coda ordinata: ");
    // perche' anche q ora e' ordinata?
    stampaQ(q);
  }
  
  private static void stampaQ (Queue input) 
  {
    Queue q = CloneQ.clone(input);
    while (!q.isEmpty()) 
      System.out.print(q.dequeue() + " ");
    System.out.println();
  }
}

