import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.IOException;

public class SafeConsoleReader extends ConsoleReader
{ 
   public SafeConsoleReader(InputStream inStream)
   {  
     super(inStream); 
   }
   
  
   public int readInt() 
   {    
     int n = 0;
     boolean lettura = true;
     while(lettura) {
       try {
	 n = super.readInt();
	 lettura = false;
       }
       catch (NumberFormatException e) {
	 System.out.print("Errore formato. Ripetere l'inserimento: ");
       }
     }
     return n;
   }
   
   public double readDouble() 
   {  
     double x = 0;
     boolean lettura = true;
     while(lettura) {
       try {
	 x = super.readDouble();
	 lettura = false;
       }
       catch (NumberFormatException e) {
	 System.out.print("Errore formato. Ripetere l'inserimento: ");
       }
     }
     return x;
   }
}

