class Giocatore {

	private String nome;
	private String squadra;
	private int numero;
	private String ruolo;

	public Giocatore(String _nome, String _ruolo, int _numero, String _squadra)
	{
		nome=_nome;  
		numero=_numero;
		ruolo=_ruolo;
		squadra=_squadra;
	}
	
	public String getNome()
	{return nome;}
	
	public String getSquadra()
	{return squadra;}


	public String toString()
	{
		String ret = "Giocatore[nome: "+ nome + " ruolo: "+ ruolo + " numero: " + numero
		+ "squadra: " + squadra;
		return ret;
	}
}

class Goal{

	private int minuto;
	private boolean autogoal;
	private Giocatore marcatore;

	public Goal(int _minuto, boolean _autogoal, Giocatore _marcatore)
	{
		minuto=_minuto;
		autogoal=_autogoal;
		marcatore=_marcatore;
	}
	
	public Giocatore getMarcatore()
	{return marcatore;}
	
	public int getMinuto()
	{return minuto;}
	
	public boolean autogoal()
	{return autogoal;}


	public String toString()
	{
		String ret;
		ret =  "[Goal]: minuto" + " " + minuto + " autogoal" + " " + autogoal + " marcatore" + " " + marcatore;
		return ret;
	}
}

class Partita{

	public String squadracasa;
	public String squadratrasferta;
	public String arbitro;
	public Goal[ ] goal;

	public Partita(String _squadracasa, String _squadratrasferta, String _arbitro, Goal[] _goal)
	{
		squadracasa=_squadracasa;
		squadratrasferta=_squadratrasferta;
		arbitro=_arbitro;
		goal=_goal;
	}


	public String toString()
	{
		String ret;
		ret = squadracasa + "-" + squadratrasferta +
                 ":  " + risultato()
                 + "(" + arbitro + ")" + "\n";
                for (int i=0; i<goal.length; i++) {
                     ret = ret + "   " + goal[i].getMarcatore().getNome() + " " + 
                                         goal[i].getMinuto() + "\n";
                }
		return ret;
	}


	public String vincitrice()
	{
		String ret=null;
		if (riscasa() > ristrasferta())
                   ret = squadracasa;
                if (riscasa() < ristrasferta())
                   ret = squadratrasferta;
        if (ret == null) {ret= "pari";}
		return ret;
	}
	
	public String risultato()
	{
		String ret= riscasa() + "-" + ristrasferta();
		return ret;
	}
	
	public int riscasa()
	{
		int ris = 0;
		for (int i=0; i<goal.length; i++) {
           if (goal[i].getMarcatore().getSquadra().equals(squadracasa) & (!goal[i].autogoal()))
              {ris++;}
           if (goal[i].getMarcatore().getSquadra().equals(squadratrasferta) & (goal[i].autogoal()))
              {ris++;}     
                }
         return ris;
    }
    
    public int ristrasferta()
	{
		int ris = 0;
		for (int i=0; i<goal.length; i++) {
           if (goal[i].getMarcatore().getSquadra().equals(squadratrasferta) & (!goal[i].autogoal()))
              {ris++;}
           if (goal[i].getMarcatore().getSquadra().equals(squadracasa) & (goal[i].autogoal()))
              {ris++;}      
                }
         return ris;
    }

}


public class Calcio
{

  public static void main(String argv[]) 
  {
    
   Giocatore g1 = new Giocatore("Martina","portiere",1,"Genoa");
   Giocatore g2 = new Giocatore("Aguilera","attaccante",11,"Genoa");
   Giocatore g21 = new Giocatore("Pagliuca","portiere",1,"Samp");
   Giocatore g22 = new Giocatore("Montella","attaccante",9,"Samp");
  
   Goal goal1 = new Goal(20,false,g2);
   Goal goal2 = new Goal(40,false,g2);
   Goal cart[] = {goal1,goal2};
   Partita p1 = new Partita("Genoa","Samp","Lucci",cart);
   
   System.out.println(p1);
   System.out.println(p1.vincitrice());
   System.out.println();

   Goal emptycart[] = {};
   Partita p2 = new Partita("Samp","Genoa","Trentalange",emptycart);

   System.out.println(p2);
   System.out.println(p2.vincitrice());

  }


}
