class Paese
{
  private double area;
  private double popolazione;
  private String nome;

  public Paese(String n, double a, double p)
  { 
    area = a;
    popolazione = p;
    nome = n;
  }

  public Paese()
  { 
    area = 0;
    popolazione = 0;
    nome = "";
  }

  public String getNome()
  { 
    return nome;
  }

  public double getArea()
  { 
    return area;
  }

  public double getPopolazione()
  { 
    return popolazione;
  }

  public double getDensita()
  { 
    if (area != 0)
      return (popolazione / area);
    else
      return Double.MAX_VALUE;
  }
}

public class StatistichePaese
{ 
  public static void main(String[] args)
  { 
    Paese maxArea = new Paese();
    Paese maxPop = new Paese();
    Paese minDens = new Paese();

    String risposta;
    ConsoleReader console = new ConsoleReader(System.in);

    do
      { 
	System.out.print("Inserire il nome del paese: ");
	String n = console.readLine();
	System.out.print("Inserire l'area (in kmq): ");
	double a = console.readDouble();
	System.out.print("Inserire la popolazione: ");
	double pop = console.readDouble();
	Paese p =  new Paese(n, a, pop);
	if (a > maxArea.getArea())
	  maxArea = p;
	if (pop > maxPop.getPopolazione())
	  maxPop = p;
	if (p.getDensita() < minDens.getDensita())
	    minDens = p;
     
	System.out.print("Vuoi inserire i dati di un altro paese? (S/N) ");
	risposta = console.readLine();
      } 
    while (risposta.equalsIgnoreCase("S"));
  
    System.out.println();
    System.out.println(maxArea.getNome() + " e' il paese con l'area piu' grande, pari a " + maxArea.getArea() + " kmq.");
    System.out.println(maxPop.getNome() + " e' il paese con la popolazione piu' numerosa, pari a " + maxPop.getPopolazione() + " persone.");
    System.out.println(minDens.getNome() + " e' il paese con la minore densita' abitativa, pari a " + minDens.getDensita() + " persone per kmq.");
  } 
}
