class Complex
{
    private double pR;
    private double pI;

    public Complex(double a, double b)
    {
	pR = a;
	pI = b;
    } 
    
    public Complex()
    {
	this(0,0);
    } 
    
    public Complex add(Complex c)
    {
	return new Complex(this.pR + c.pR, this.pI + c.pI);
    } 
    
    
    public Complex subtract(Complex c)
    {
	return new Complex(this.pR - c.pR, this.pI - c.pI);
    } 
    
    public Complex multiply(Complex c)
    {
	return new Complex(this.pR * c.pR - this.pI * c.pI, this.pI * c.pR + this.pR * c.pI);
    } 
   

    public double mod()
    {
	return Math.sqrt(pR * pR + pI * pI);
    } 
    
    
    public String toString()
    {
	if(pI < 0)
	    return pR + " - i * " + (-pI);
	else
	    return pR + " + i * " + pI;
    } 
} 

public class TestComplex
{
    public static void main(String[] args)
    {
	ConsoleReader console = new ConsoleReader(System.in);
	System.out.println("Inserire il primo numero complesso.");
	System.out.print("Parte reale: ");
	double a = console.readDouble();
	System.out.print("Parte immaginaria: ");
	double b = console.readDouble();
	Complex c1 = new Complex(a,b);
	System.out.println("Inserire il secondo numero complesso.");
	System.out.print("Parte reale: ");
	a = console.readDouble();
	System.out.print("Parte immaginaria: ");
	b = console.readDouble();
	Complex c2 = new Complex(a,b);
	System.out.println("\nNumeri inseriti:");
	System.out.println("c1 = " + c1.toString());
	System.out.println("c2 = " + c2.toString());
	System.out.println("\nOperazioni:");
	System.out.println("c1 + c2 = " + c1.add(c2).toString());
	System.out.println("c1 - c2 = " + c1.subtract(c2).toString());
	System.out.println("c1 * c2 = " + c1.multiply(c2).toString());
	System.out.println("|c1| = " + c1.mod());
	System.out.println("|c2| = " + c2.mod());
    } 
} 



